' Sortierfelder berschreiben
'
' Das Skript beschreibt alle Sortierfelder - ob leer oder bereits
' befllt - der aktuell selektierten Titel. Der Inhalt stammt aus den
' dazugehrigen Feldern, wobei Artikel wie "The", "Der", "Die", "Das",
' "Le" oder "La" herausgefiltert werden. Ebenso werden bestimmte
' Sonderzeichen am Textanfang  wie Anfhrungszeichen oder eine geffnete
' Klammer nicht bercksichtigt.
'
' (c) 2007-2015 Gerald Erdmann
'
' Skript aus dem Buch "iPod + iTunes", erscheinen bei O'Reilly
' Weitere Details finden Sie unter http://www.ipodbuch.de.
' Fr etwaige Fehler oder Datenverluste wird keine Garantie
' bernommen. Benutzung auf eigene Gefahr!
'
' Zur Installation das Skript an eine beliebige Stelle kopieren.
' Das Skript kann nicht direkt aus iTunes heraus aufgerufen werden,
' sondern wird direkt aus dem Windows Explorer gestartet.
'
' Version 1.0  Juni 2007  Erste Version
' Version 1.1  Sep. 2010  Fix fr iTunes 10
' Version 1.2  Jan. 2015  Fix fr iTunes 12
'

dim iTunes
dim tracklist
dim track
dim counter
dim aWord, sortString
dim filterList (14)

filterList(0) = "the "
filterList(1) = "der "
filterList(2) = "die "
filterList(3) = "das "
filterList(4) = "la "
filterList(5) = "le "
filterList(6) = "les "
filterList(7) = "a "
filterList(8) = " "
filterList(9) = "... "
filterList(10) = "("
filterList(11) = "#"
filterList(12) = Chr(34)
filterList(13) = "'"
filterList(14) = "..."

set iTunes = CreateObject ("iTunes.Application")
set tracklist = iTunes.SelectedTracks
set iTunesTracks = itunes.LibraryPlaylist.Tracks

redim brokenTracks (iTunesTracks.count)
counter = 0

if left (iTunes.Version, 3) <> "10." and left (iTunes.Version, 3) <> "11." and left (iTunes.Version, 3) <> "12."  and left (iTunes.Version, 3) <> "13." and iTunes.Version < "7.1" then
  WScript.Echo "Sie bentigen iTunes 7.1 oder hher fr dieses Skript!"
else
  if tracklist is nothing then
    WScript.Echo "Sie haben keine Titel selektiert!"
  else
    for track = tracklist.Count to 1 step -1
      call sortierfeld (tracklist.Item(track).Album, tracklist.Item(track).SortAlbum)
      if sortString <> "" then
        tracklist.Item(track).SortAlbum = sortString
      end if
      call sortierfeld (tracklist.Item(track).Artist, tracklist.Item(track).SortArtist)
      if sortString <> "" then
        tracklist.Item(track).SortArtist = sortString
      end if
      call sortierfeld (tracklist.Item(track).AlbumArtist, tracklist.Item(track).SortAlbumArtist)
      if sortString <> "" then
        tracklist.Item(track).SortAlbumArtist = sortString
      end if
      call sortierfeld (tracklist.Item(track).Name, tracklist.Item(track).SortName)
      if sortString <> "" then
        tracklist.Item(track).SortName = sortString
      end if
      call sortierfeld (tracklist.Item(track).Composer, tracklist.Item(track).SortComposer)
      if sortString <> "" then
        tracklist.Item(track).SortComposer = sortString
      end if
      call sortierfeld (tracklist.Item(track).Show, tracklist.Item(track).SortShow)
      if sortString <> "" then
        tracklist.Item(track).SortShow = sortString
      end if
    next

    if counter = 0 then
      WScript.Echo "Es wurde kein Sortierfeld berschrieben!"
    elseif counter = 1 then
      WScript.Echo "Es wurde ein Sortierfeld berschrieben!"
    else
      WScript.Echo "Es wurden " & counter & " Sortierfelder berschrieben!"
    end if
  end if
end if


function sortierfeld (field, sortfield)
  sortString = ""
  if field <> "" then
    for each aWord in filterList
      if InStr (LCase (field), aWord) = 1 then
        sortString = LTrim (Right (field, Len (field) - Len (aWord)))
        counter = counter + 1
      end if
    next
  end if
end function